<?php

  class sml_users_morceaux extends sml_mod
  {
    var $groupes;
    var $albums;
    var $morceau;
    var $user;
    var $status;
    var $album_status_id;
    var $morceau_status_id;

    function validate(&$env)
    { $data = $env->data();
      if(($this->status = $data->source_status()) !== false)
      { foreach($this->status as $id_source_status => $source_status)
        { if($source_status["nom"] == "album") $this->album_status_id = $id_source_status;
          if($source_status["nom"] == "morceau") $this->morceau_status_id = $id_source_status;
          if(isset($this->album_status_id) && isset($this->morceau_status_id)) break;
        }
        if(isset($this->album_status_id) && isset($this->morceau_status_id))
        { if($this->user = $env->user())
          { if(($this->groupes = $data->groupes($this->user["id"])) !== false)
            { $env->set_out("groupes", $this->groupes);
              $this->albums = array();
              if($this->groupes["total"] > 0)
              { $select = array();
                $select["status"] = $this->album_status_id;
                $select["id_user"] = $this->user["id"];
                foreach($this->groupes["list"] as $id_groupe => $groupe)
                { $select["id_groupe"] = $id_groupe;
                  if(($albums = $data->sources($select)) !== false)
                  { $this->albums[$id_groupe] = $albums["list"];
                  }
                  else $this->albums = false;
                }
              }
              if($this->albums !== false)
              { $env->set_out("albums", $this->albums);
                if($env->etat("action") == "edit" || $env->etat("action") == "del")
                { if(($this->morceau = $data->source($_GET[$env->param("id")])) !== false && $this->morceau)
                  { if(isset($this->groupes["list"][$this->morceau["id_groupe"]]))
                    { $this->morceau["is_reference"] = $this->morceau["reference"] ? "1" : "0";
                    }
                    else return "Vous n'est pas autoris&eacute; &agrave; modifier ce morceau";
                  }
                  else return "Impossible de lire les informations du morceau";
                }
                if($env->etat("action") == "add" || $env->etat("action") == "edit")
                { if(($this->licences = $data->licences()) !== false)
                  { $env->set_out("licences", $this->licences);
                  }
                  else return "Impossible de lire la liste des licences";
                }
              }
              else return "Impossible de lire la liste des albums";
            }
            else return "Impossible de lire la liste des groupes";
          }
          else return "Vous devez &ecirc;tre identifier pour acc&eacute;der &agrave; cette page";
        }
        else
        { if(!isset($this->album_status_id)) return "Type de source inconnu: album";
          return "Type de source inconnu: morceau";
        }
      }
      else return "Impossible de lire la liste des status de source";
      return true;
    }

    function index(&$env)
    { $data = $env->data();
      $select = array();
      $select["status"] = $this->morceau_status_id;
      $select["id_user"] = $this->user["id"];
      $select["order_by"] = "ordre";
      if(isset($_GET[$env->param("groupe")]) && $_GET[$env->param("groupe")]) $select["id_groupe"] = $_GET[$env->param("groupe")];
      if(isset($_GET[$env->param("album")]) && $_GET[$env->param("album")]) $select["id_composition"] = $_GET[$env->param("album")];
      $select["start"] = isset($_GET[$env->param("start")]) && $_GET[$env->param("start")] ? $_GET[$env->param("start")] : 0;
      if(($morceaux = $data->sources($select)) !== false)
      { $env->set_out("morceaux", $morceaux);
        if($_POST)
        { $OK = true;
          foreach($morceaux["list"] as $id_morceau => $morceau)
          { if(isset($_POST["ordre_".$id_morceau]))
            { if
              ( ( $data->set_source
                  ( $morceau["id"],
                    $morceau["id_groupe"],
                    $morceau["nom"],
                    $morceau["documents"],
                    $morceau["licence"],
                    $morceau["reference"],
                    $morceau["status"],
                    array
                    ( "date_inscription" => $_POST["date_inscription"],
                      "ordre" => $_POST["ordre_".$id_morceau],
                      "description" => $morceau["description"]
                    )
                  )
                ) === false
              )
              { $OK = false;
                break;
              }
            }
          }
          if($OK)
          { $get_params = array();
            if(isset($_GET[$env->param("groupe")]) && $_GET[$env->param("groupe")]) $get_params["groupe"] = $_GET[$env->param("groupe")];
            if(isset($_GET[$env->param("album")]) && $_GET[$env->param("album")]) $get_params["album"] = $_GET[$env->param("album")];
            $env->redirect
            ( $env->url("users/morceaux", $get_params),
              "l'ordre des morceaux a &eacute;t&eacute; enregistr&eacute;"
            );
          }
          else $env->erreur("Impossible d'enregistrer l'ordre des morceaux");
        }
      }
      else $env->erreur("Impossible de lire la liste des morceaux");
    }

    function add(&$env)
    { $data = $env->data();
      if($data->check_user_uploads_dir())
      { $web_path = $env->path("web");
        $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
        if($_POST)
        { $_POST["documents"] = array();
          foreach($_POST as $post_key => $post_value)
          { if(substr($post_key, 0, 13) == "document_nom_")
            { if($id_document = substr($post_key, 13))
              { $_POST["documents"][$id_document] = array
                ( "nom" => $_POST["document_nom_".$id_document],
                  "url" => $_POST["document_url_".$id_document]
                );
              }
            }
          }
          $env->set_out("morceau", $_POST);
          $id_source = false;
          if($_POST["is_reference"])
          { if(trim($_POST["reference"]))
            { if
              ( ( $id_source = $data->add_source
                  ( $_POST["id_groupe"],
                    "",
                    "",
                    "",
                    $_POST["reference"],
                    $this->morceau_status_id,
                    array
                    ( "date_inscription" => date("Y")."-".date("m")."-".date("d")
                    )
                  )
                ) === false
              ) $env->erreur("Impossible d'ajouter le morceau");
            }
            else $env->message("Merci de pr&eacute;ciser l'url du fichier XML");
          }
          else
          { if(trim($_POST["nom"]))
            { if
              ( ( $id_source = $data->add_source
                  ( $_POST["id_groupe"],
                    $_POST["nom"],
                    $_POST["documents"],
                    $_POST["licence"],
                    null,
                    $this->morceau_status_id,
                    array
                    ( "date_creation" => $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"],
                      "date_inscription" => date("Y")."-".date("m")."-".date("d"),
                      "description" => $_POST["description"],
                      "ordre" => 0
                    )
                  )
                ) === false
              ) $env->erreur("Impossible d'ajouter le morceau");
            }
            else $env->message("merci de pr&eacute;ciser un nom pour le morceau");
          }
          if($id_source)
          { if($_POST["album"])
            { if($data->set_source_composition($id_source, $_POST["album"]))
              { $env->redirect
                ( $env->url("users/morceaux"),
                  "le morceau a &eacute;t&eacute; ajout&eacute;"
                );
              }
              else $env->erreur("Le morceau a &eacute;t&eacute; ajout&eacute; mais impossible de l'associer &agrave; cet album");
            }
            else $env->redirect
            ( $env->url("users/morceaux"),
              "le morceau a &eacute;t&eacute; ajout&eacute;"
            );
          }
        }
      }
      else $env->erreur("Impossible de creer le repertoire utilisateur");
    }

    function edit(&$env)
    { $data = $env->data();
      if($data->check_user_uploads_dir())
      { $web_path = $env->path("web");
        $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
        $id_source = $_GET[$env->param("id")];
        if($env->set_out("morceau", $this->morceau))
        { if(($compositions = $data->source_compositions(array("id_source" => $id_source))) !== false)
          { if($compositions) foreach($compositions[$id_source] as $id_album) { $this->morceau["album"] = $id_album; break; }
            $env->set_out("morceau", $this->morceau);
            if($_POST)
            { $_POST["documents"] = array();
              foreach($_POST as $post_key => $post_value)
              { if(substr($post_key, 0, 13) == "document_nom_")
                { if($id_document = substr($post_key, 13))
                  { $_POST["documents"][$id_document] = array
                    ( "nom" => $_POST["document_nom_".$id_document],
                      "url" => $_POST["document_url_".$id_document]
                    );
                  }
                }
              }
              $env->set_out("morceau", $_POST);
              if($_POST["is_reference"])
              { if(trim($_POST["reference"]))
                { if
                  ( ( $data->set_source
                      ( $id_source,
                        $_POST["id_groupe"],
                        "",
                        "",
                        "",
                        $_POST["reference"],
                        $this->morceau_status_id,
                        array
                        ( "date_inscription" => $_POST["date_inscription"],
                          "ordre" => isset($this->morceau["ordre"]) ? $this->morceau["ordre"] : 0
                        )
                      )
                    ) === false
                  ) $env->erreur("Impossible de modifier le morceau");
                }
                else $env->message("Merci de pr&eacute;ciser l'url du fichier XML");
              }
              else
              { if(trim($_POST["nom"]))
                { $documents = array();
                  foreach($_POST as $post_key => $post_value)
                  { if(substr($post_key, 0, 13) == "document_nom_")
                    { if($id_document = substr($post_key, 13))
                      { $documents[$id_document] = array
                        ( "nom" => $post_value,
                          "url" => $_POST["document_url_".$id_document]
                        );
                      }
                    }
                  }
                  if
                  ( ( $data->set_source
                      ( $id_source,
                        $_POST["id_groupe"],
                        $_POST["nom"],
                        $documents,
                        $_POST["licence"],
                        null,
                        $this->morceau_status_id,
                        array
                        ( "date_creation" => $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"],
                          "date_inscription" => $_POST["date_inscription"],
                          "description" => $_POST["description"],
                          "ordre" => isset($this->morceau["ordre"]) ? $this->morceau["ordre"] : 0
                        )
                      )
                    ) === false
                  ) $env->erreur("Impossible de modifier le morceau");
                }
                else $env->message("merci de pr&eacute;ciser un nom pour le morceau");
              }
              if(!$env->out("messages") && !$env->out("erreur"))
              { if($_POST["album"])
                { if($data->del_source_compositions(array("id_source" => $id_source)))
                  { if($data->set_source_composition($id_source, $_POST["album"]))
                    { $env->redirect
                      ( $env->url("users/morceaux"),
                        "le morceau a &eacute;t&eacute; modifi&eacute;"
                      );
                    }
                    else $env->erreur("Le morceau a &eacute;t&eacute; modifi&eacute; mais impossible de l'associer &agrave; cet album");
                  }
                  else $env->erreur("Le morceau a &eacute;t&eacute; modifi&eacute; mais impossible de l'associer &agrave; cet album");
                }
                else $env->redirect
                ( $env->url("users/morceaux"),
                  "le morceau a &eacute;t&eacute; modifi&eacute;"
                );
              }
            }
          }
          else return "Impossible de lire les informations du morceau";
        }
        else $env->erreur("Impossible de lire la liste des compositions");
      }
      else $env->erreur("Impossible de creer le repertoire utilisateur");
    }

    function del(&$env)
    { $data = $env->data();
      if($data->del_source($this->morceau["id"]))
      { $env->redirect
        ( $env->url("users/morceaux"),
          "le morceau a &eacute;t&eacute; supprim&eacute;"
        );
      }
      else $env->erreur("Impossible de supprimer le morceau");
    }

  }

?>