<?php

  # FICHIER A ADAPTER EN FONCTION DE VOTRE INSTALLATION

  # si vous avez mis tel quel sur votre serveur, a la racine, le dossier "sourceml"
  # et que vous voulez le stockage des donnees en XML alors vous ne devriez pas
  # avoir a modifier ce fichier.

  # si vous installez les fichiers dans un autre dossier que "sourceml",
  # et/ou que ce dossier n'est pas a la racine du site, precisez-le
  # dans la configuration suivante :

  # chemin web du site (dossier d'execution du script d'appel)
  # absolu a partir de la racine du site

  $PATHES["web"] = "/sourceml";

  # les chemins suivant sont des chemins internes a sourceML

  # chemin de l'application
  # relatif au dossier d'execution du script
  $PATHES["app"] = "app";

  # nom du dossier (sans chemin) de l'application courante
  $PATHES["current_app"] = "local";

  # nom du dossier (sans chemin) de l'application par defaut
  $PATHES["core_app"] = "core";

  # dossier des librairies
  # relatif au dossier d'execution du script
  $PATHES["libs"] = "libs";

  # dossier des contenus editables par l'application
  # relatif au dossier d'execution du script
  $PATHES["content"] = "content";

  # dossier des templates
  # relatif au dossier d'execution du script
  $PATHES["out"] = "out";

  # nom du dossier (sans chemin) du template courant
  $PATHES["current_out"] = "local";

  # nom du dossier (sans chemin) du template par defaut
  $PATHES["dist_out"] = "dist";

  # --------------------------------------------------------------
  #                                                base de donnees
  # "mysql", "sqlite" ou "xml"
  # ATTENTION : pour le moment, seul "xml" fonctionne

  # --------------------------- MYSQL

/*
  $bdd["sgbd"] = "mysql";
  $bdd["host"] = "localhost";
  $bdd["base"] = "sourceml_base";
  $bdd["table_prefix"] = "sml_";
  $bdd["user"] = "mysql_user";
  $bdd["password"] = "mysql_pass";
*/

  # --------------------------- SQLITE

/*
  $bdd["sgbd"] = "sqlite";
  $bdd["host"] = "content/data/sqlite";
  $bdd["base"] = "sourceml_base.sqlite";
  $bdd["table_prefix"] = "sml_";
*/

  # --------------------------- XML


  $bdd["sgbd"] = "xml";
  $bdd["host"] = "content/data/xml";
  $bdd["base"] = "sourceml";
  $bdd["table_prefix"] = "sml_";

  # --------------------------------------------------------------
  #                                                  configuration
  #

  $CONFIG["version"] = "<a href=\"http://www.sourceml.com/\">sourceML 0.7</a>";

?>