<?php

  class sml_data_sources_xml extends sml_data
  {

    function set_source_xml($id, $params = array())
    { $env = $this->env();
      $OK = false;
      if(strlen($id) > 0 && ($fh = @fopen($env->path("content")."sources/".$id.".xml", "wb")) !== false)
      { if(($content = $this->source_xml_content($id, $params)) !== false)
        { if(@fwrite($fh, $content)) $OK = true;
        }
        @fclose($fh);
      }
      return $OK;
    }

    function del_source_xml($id)
    { $env = $this->env();
      if(file_exists($env->path("content")."sources/".$id.".xml"))
      { return @unlink($env->path("content")."sources/".$id.".xml");
      }
      return true;
    }

    function maj_source_xml_groupe($groupe)
    { $OK = true;
      if($groupe !== false)
      { $sgbd = $this->sgbd();
        $env = $this->env();
        if($rst = $sgbd->open_data("sources"))
        { while($source = $sgbd->fetch_data($rst))
          { if(isset($source))
            { if($source["id_groupe"] == $groupe["id"])
              { if(!$this->set_source_xml($source["id"], array("source" => $source, "groupe" => $groupe)))
                { $OK = false;
                  break;
                }
              }
            }
            else
            { $OK = false;
              break;
            }
          }
          $sgbd->close_data($rst);
        }
        else $OK = false;
      }
      else $OK = false;
      return $OK;
    }

    function maj_source_xml_licence($licence)
    { $OK = true;
      if($licence !== false)
      { $sgbd = $this->sgbd();
        $env = $this->env();
        if($rst = $sgbd->open_data("sources"))
        { while($source = $sgbd->fetch_data($rst))
          { if(isset($source))
            { if($source["licence"] == $licence["id"])
              { if(!$this->set_source_xml($source["id"], array("source" => $source, "licence" => $licence)))
                { $OK = false;
                  break;
                }
              }
            }
            else
            { $OK = false;
              break;
            }
          }
          $sgbd->close_data($rst);
        }
        else $OK = false;
      }
      else $OK = false;
      return $OK;
    }

    function source_xml_url($id_source)
    { $env = $this->env();
      return "http://".$_SERVER["SERVER_NAME"].$env->path("web").$env->path("content")."sources/".$id_source.".xml";
    }

  }

?>